/**  Simple test of RayCasting by Purobaz   **/

#include <fxlib.h>
#include "RayCasting.h"
#include "MonochromeLib.h"

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int key, cur;
	char c1[1], c2[1];
	float moveSpeedMul = 3, rotSpeedMul = 2;
	int dotSize = 1;
	
	while(1) {
		key = 1; cur = 0;
		
		//menu to choose the 3 parameters
		while(key != KEY_CTRL_EXE) {
			ML_clear_vram();
			locate(1, 1); Print("RayCasting Engine");
			locate(10, 8); Print("Purobaz 2014");
			locate(1, 3); Print("Move speed");
			locate(1, 4); Print("Rotation speed");
			locate(1, 5); Print("Dot size");
			locate(12, 3);
			intToChar(&c1, (int)moveSpeedMul);
			intToChar(&c2, (int)(10 * (moveSpeedMul - (int)moveSpeedMul)));
			if(cur == 0) {PrintRev(&c1); PrintRev("."); PrintRev(&c2);}
			else {Print(&c1); Print("."); Print(&c2);}
			locate(16, 4);
			intToChar(&c1, (int)rotSpeedMul);
			intToChar(&c2, (int)(10 * (rotSpeedMul - (int)rotSpeedMul)));
			if(cur == 1) {PrintRev(&c1); PrintRev("."); PrintRev(&c2);}
			else {Print(&c1); Print("."); Print(&c2);}
			locate(10, 5);
			intToChar(&c1, dotSize);
			if(cur == 2) PrintRev(&c1);
			else Print(&c1);
			ML_display_vram();
			
			GetKey(&key);
			if(key == KEY_CTRL_UP && cur > 0) cur--;
			if(key == KEY_CTRL_DOWN && cur < 2) cur++;
			if(key == KEY_CTRL_RIGHT)
			{
				if(cur == 0 && moveSpeedMul < 9.9) moveSpeedMul += 0.1;
				if(cur == 1 && rotSpeedMul < 9.9) rotSpeedMul += 0.1;
				if(cur == 2 && dotSize < 4) dotSize++;
			}
			if(key == KEY_CTRL_LEFT)
			{
				if(cur == 0 && moveSpeedMul > 0.2) moveSpeedMul -= 0.1;
				if(cur == 1 && rotSpeedMul > 0.2) rotSpeedMul -= 0.1;
				if(cur == 2 && dotSize > 1) dotSize--;
			}
		}
		
		//RayCasting
		RC_Engine(moveSpeedMul, rotSpeedMul, dotSize);
	}
    return 1;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section